#include <bits/stdc++.h>
using namespace std;

bool otazka(int a, int b, int c) {
    cout << 0 << " " << a << " " << b << " " << c << endl << flush;
    int ans;
    cin >> ans;
    return ans > 0;
}

bool je_hrana(int N, int a, int b) {
    for (int c=1; c<=N; ++c) if (c != a && c != b) if (otazka(a,c,b)) return false;
    return true;
}

int main() {
    int K, L;
    cin >> K >> L;
    int N = (1 << (K+1)) - 1;
    
    vector<vector<int> > graf(N+1);
    for (int a=1; a<=N; ++a) for (int b=1; b<a; ++b) if (je_hrana(N,a,b)) {
        graf[a].push_back(b);
        graf[b].push_back(a);
    }

    int koren = 0;
    while (graf[koren].size() != 2u) ++koren;
    queue<int> Q;
    Q.push(koren);
    vector<bool> visited(N+1,false);
    vector<vector<int> > odpovede(N+1);
    while (!Q.empty()) {
        int where = Q.front(); Q.pop();
        visited[where] = true;
        for (int x : graf[where]) {
            if (visited[x]) continue;
            odpovede[where].push_back(x);
            Q.push(x);
        }
    }
    cout << 1 << endl << flush;
    for (int n=1; n<=N; ++n) {
        cout << odpovede[n].size();
        for (int x : odpovede[n]) cout << " " << x;
        cout << endl << flush;
    }
}
